package org.datamanager.collector.helpers.email;

import java.util.Vector;
import java.util.StringTokenizer;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;

/**
Author: Manoj Shanbhag (mshanbha@cs.indiana.edu)
Group : Networks
Date  : Nov 4, 1998
Modified: December 5, 1999, gregory j. e. rawlins

Responsibilities:
This class finds all isolated URLs within a string.
(An isolated URL is one that is preceded by a blank, a newline, a tab,
or a double quote.)
**/

public class UrlParser
	{
	public final static String URL_DELIMITERS = " \n\t\"";

	/**
	Find all isolated URLs in the given string
	and return them in a Vector
	**/
	public Vector getURLs(String string)
		{
		Vector urls = new Vector();
		String token = "";
		StringTokenizer tokenizer =
			new StringTokenizer(string, UrlParser.URL_DELIMITERS);
		while (tokenizer.hasMoreTokens())
			{
			token = tokenizer.nextToken();
			if (token.startsWith("http://"))
				urls.addElement(token);
			}

		return urls;
		}

	/**
	Test this class by passing it the name of a file to parse for URLs
	**/
	public static void main(String[] parameters)
		{
		//make sure the input is sane
		String filePathName;
		if (parameters.length == 1)
			filePathName = parameters[0];
		else
			{
			System.out.println("Usage: java UrlParser <fileName>");
			return;
			}

		//try to read up to MAXINT bytes of the named file
		File fileName = null;
		byte[] fileData = null;
		try
			{
			fileName = new File(filePathName);
			FileInputStream stream = new FileInputStream(fileName);
			fileData = new byte[(int) fileName.length()];
			int len = stream.read(fileData); //variable unused
			stream.close();
			}
		catch (IOException exception)
			{
			exception.printStackTrace();
			return;
			}

		//print any URLs present
		String string = new String(fileData);
		UrlParser urlParser = new UrlParser();
		Vector urls = urlParser.getURLs(string);
		for (int i = 0; i < urls.size(); i++)
			{
			String urlString = (String) urls.elementAt(i);
			System.out.println("URL " + i + " = " + urlString);
			}
		}
	}
