package org.datamanager.constraint;

import org.datamanager.kernel.AbstractEventConstraint;
import org.datamanager.constraint.EntityConstraint;
import org.datamanager.constraint.EventTypeIsConstraint;
import org.datamanager.event.AddEntityEvent;
import org.datamanager.event.DataManagerEvent;


public class AddedEntitySatisfiesConstraint
	extends AbstractEventConstraint
	{
	private static final EventConstraint eventConstraint =
		new EventTypeIsConstraint(AddEntityEvent.class);
	private EntityConstraint entityConstraint;
	
	public AddedEntitySatisfiesConstraint(EntityConstraint constraint)
		{
		this.entityConstraint = constraint;
		}

	public boolean describes(DataManagerEvent event)
		{
		if (eventConstraint.accepts(event))
			{
			return entityConstraint.accepts(
				((AddEntityEvent) event).getAddedEntity());
			}
		
		return false;
		}
	}