/**
 * InterfaceNameContainsConstraint.java
 * @author Gordon Murphy
 *
 * Created: 199910071638
 */

package org.datamanager.constraint;

import org.datamanager.kernel.Entity;

import org.datamanager.exception.DataManagerException;
import org.datamanager.kernel.AbstractEntityConstraint;
import org.datamanager.passiveentityvalue.StringEntityValue;
public class InterfaceNameContainsConstraint extends AbstractEntityConstraint {
	private String name;
	
	public InterfaceNameContainsConstraint(String name) {
		this.name = name;
		}
	
	public boolean describes(Entity entity) {
		boolean temp = false;
		try {
			String entityName = entity.getName();
			Entity[] attributes = entity.getAttributes(new 
NameEqualsConstraint("InterfaceName"));
			for (int i = 0; i < attributes.length; i++) {
				StringEntityValue value = (StringEntityValue)(attributes[i].getValue());
				if (value.indexOf(name) >= 0) {
					temp = true;
					break;
					}
				}
			}
      	  catch (DataManagerException e) {
			e.printStackTrace();
			}
		return temp;
		}
	} // InterfaceNameContainsConstraint
