/**
 * NotConstraint.java
 *
 *
 * Created: Thu Oct  7 15:43:17 1999
 *
 * @author Benjamin Keil
 * @author Matthew Farrellee
 * @version
 */

package org.datamanager.constraint;

import org.datamanager.kernel.Entity;
import org.datamanager.event.DataManagerEvent;

public class NotConstraint implements EntityConstraint, EventConstraint
	{
    
    private EntityConstraint negatedEntity;

	private EventConstraint negatedEvent;

    public NotConstraint(EntityConstraint negated) {
	this.negatedEntity = negated;
    }

    public NotConstraint(EventConstraint negated) {
	this.negatedEvent = negated;
    }

    public boolean accepts(Entity defendant)
    {
	return ((negatedEntity != null) && !negatedEntity.accepts(defendant));
    }

    public boolean accepts(DataManagerEvent defendant)
    {
	return ((negatedEvent != null) && !negatedEvent.accepts(defendant));
    }
    
} // NotConstraint
