/**
 * ValueEqualsConstraint.java
 * @author Benjamin Keil
 * @author Matthew Farrellee
 *
 * Created 199910111454
 */

package org.datamanager.constraint;

import java.io.Serializable;

import org.datamanager.kernel.Entity;
import org.datamanager.kernel.EntityValue;

import org.datamanager.exception.DataManagerException;
import org.datamanager.kernel.AbstractEntityConstraint;

public class ValueEqualsConstraint extends AbstractEntityConstraint
{
    
    private EntityValue target;

    public ValueEqualsConstraint(EntityValue target)
        {
        this.target = target;
        }

    public boolean describes(Entity defendant)
        {
        Serializable val;

        try
            {
            val = defendant.getValue();
            return (target.equals(val));
            }
        catch (DataManagerException e)
            {
            e.printStackTrace();
            }
        return false;
        }
    } // ValueEqualsConstraint

