package org.datamanager.engine.filter;

import java.util.*;

/**
 * This class allows to compose filters.
 *
 * @author Aleksander Slominski
 */
public class CompositeFilter implements Filter{
    /** @serial */
    private List pipeline = new Vector();

    public CompositeFilter() {
    }


    public void addFilter(Filter f) {
	pipeline.add(f);
    }

    public Object process(Object input){
	Object output = input;
	for(int i = 0; i < pipeline.size(); ++i) {
	    Filter f = (Filter) pipeline.get(i);
	    output = f.process(input);
	    input = output;
	}	
	return output;
    }


}
