package org.datamanager.engine.filter;

/**
 * This subclass of WordRemoverFilter removes specifically Determiner words.
 *
 * @author Chao
 * @author Aleksander Slominski
 */

public class DetWordFilter extends WordRemovingFilter{

  /** The static string variable is a list of all the Determiner Words. */

  private static String list[] = {
"all",
"an",
"another",
"any",
"anybody",
"anyone",
"anything",
"billion",
"both",
"eight",
"eighty",
" eleven",
"every",
"everybody",
"everyone",
"everything",
"everywhere",
"few",
"fifth",
"fifteen",
"fifty",
"first",
"five",
"four",
"fourteen",
"forty",
"hundred",
"last",
"many",
"million",
"most",
"much",
"neither",
"nine",
"ninety",
"nineteen",
"no",
"nobody",
"none",
"nothing",
"other",
"second",
"seven",
"six",
"sixty",
"somebody",
"somehow",
"some",
"someone",
"something",
"ten",
"the",
"three",
"hundred",
"twelve",
"twenty",
"thirteen",
"thirty",
"two",
  };

  //////////////////////////////////////////////////////////////////

  /* This constructor reads in the list of Determiner words.
   * When a document comes in, the words in the document are compared
   * with the Determiner words and the ones that match are removed by the
   * method 'process' in super class WordRemoverFilter
   */

  public DetWordFilter() {
            super (list);
  }


}
