package org.datamanager.engine.filter;

/**
 * This class implements the filter class. <p>
 It's sole purpose is to remove text within html tags. It's constructor does 
 not take any arguments and its process method takes an object.
 *
 * @author Chao
 */

import java.util.*;
import java.io.*;
import java.lang.*;

public class HTMLFilter implements Filter{

    
    public HTMLFilter(){}


    /** This method does the actual removal of the tags from the string. <p> It takes in an object string 
	as its argument and returns an object.*/
    public Object process(Object content){
	if(content instanceof String == false)
	    throw new IllegalArgumentException("Expected string");
	StringBuffer buffer = new StringBuffer(); 
	StringBuffer entitybuffer = new StringBuffer();
	String newcontent = content.toString();
	int len = newcontent.length();
	boolean inEntity = false;/** &[a-z]+;*/
	boolean inTag = false;/** <[]>*/
	for(int i = 0; i < len; ++i) {
	    char character = newcontent.charAt(i);

	    if (character=='<')
		inTag = true;
	    
	    if (!inTag){
		if (inEntity){
		    entitybuffer.append(character);
		    if(character == ';'){ 
			inEntity = false;
			buffer.append(entitybuffer);
		    } else if(! Character.isLetter(character)){ 
			inEntity = false;
		    }
		} else {
		    buffer.append(character);
		}
	    }
	    if (!inTag){
		if (inEntity){
		    entitybuffer.append(character);
		    if(character == '&'){ 
			inEntity = false;
			buffer.append(entitybuffer);
		    } else if(! Character.isLetter(character)){ 
			inEntity = false;
		    }
		}
		
	    }
	    if (character=='>')
		inTag = false;
	   
	   
	}	
        return buffer.toString();
    }

    /** This is the main method of the class for testing. */
 
    public static void main(String args[]){

	String stringWithTags = "<html>This string will be removed out of html tags. </b> I suppose"+
"we could add some <!-- comments as well to see what happens --></html>" ;

	HTMLFilter htmlfilter = new HTMLFilter();
	String output = new String();
	output= (String)htmlfilter.process(stringWithTags);

	System.out.println(output);

    }

}




	    
