package org.datamanager.engine.test;

import org.datamanager.engine.filter.*;
import java.io.*;
import test.framework.*;

/**
 * Simple module tests with JUnit.
 *
 * This class is used to test HTMLFilter.java class. It extends TestCase and it's constructor
 * takes a string name as its argument.
 *
 * @author Chao
 */

public class HTMLFilterTest extends TestCase{

    public HTMLFilterTest(String name) {
        super(name);
    }

    public void testStringFiltering() {
       HTMLFilter htmlfilter = new HTMLFilter();
     String i1 = "<H2><I>Leading the Web to its Full Potential...</I></H2><H2>W3C Issues First Public Working Draft for MathML 2.0</H2>";

       String o1 = (String)htmlfilter.process(i1);
    
       assertEquals(o1,"Leading the Web to its Full Potential...W3C Issues First Public Working Draft for MathML 2.0");

    }

    public static Test suite() {
        TestSuite suite= new TestSuite();

        suite.addTest(new HTMLFilterTest("testStringFiltering"));
        return suite;
    }

    public static void main (String[] args) {
        test.textui.TestRunner.run (suite());
    }

}

