package org.datamanager.engine.test;

import org.datamanager.engine.filter.*;
import java.io.*;
import test.framework.*;

/**
 * Simple module tests with JUnit.
 *
 * This class is used to test StopWordFilter.java class. It extends TestCase and it's constructor
 * takes a string name as its argument.
 * 
 * @author Chao
 */

public class StopWordFilterTest extends TestCase {
    public StopWordFilterTest(String name) {
        super(name);
    }

    public void testStringFiltering() {
       StopWordFilter f1 = new StopWordFilter();
       String i1 = "KnownSpace asks: where was you yesterday?";
       String o1 = (String)f1.process(i1);
       assertEquals(o1, "KnownSpace asks yesterday ");
    }
	
    public static Test suite() {
        TestSuite suite= new TestSuite();

        suite.addTest(new StopWordFilterTest("testStringFiltering"));
        return suite;
    }

    public static void main (String[] args) {
        test.textui.TestRunner.run (suite());
    }

}
