package org.datamanager.event;

import org.datamanager.event.DataManagerEvent;
import java.io.Serializable;
/**
 * This marker interface is the mother of all
 * events generated from within the kernel of
 * the <code>DataManager</code>.
 *
 * This is just a marker interface. It specifies
 * no unique methods of its own.
 * It does however extend <code>DataManagerEvent<code>
 * and therefore requires:
 * public EventGenerator getSource()
 * public long getTime()
 * public String toString()
 *
 * @author Matthew Farrellee
 */
public interface InterfaceEvent extends DataManagerEvent
    {
    }
