package org.datamanager.kernel;

import org.datamanager.kernel.EntityValue;
import org.datamanager.exception.DataManagerException;

/**
 * This abstract class represents an ActiveEntityValue. That
 * is, an EntityValue that does a bit of computation so that
 * it can return a value.
 *
 * @author Matthew Farrellee
 * @version
 */
public abstract class ActiveEntityValue implements EntityValue
   {

   /**
    * The computation that is required by this ActiveEntityValue
    * should be implemented in this method. The computation
    * must result in an EntityValue that is returned.
    */
   protected abstract EntityValue getEntityValue()
         throws DataManagerException;

   }














