/**
 * EntityValue.java
 * 
 * Created 199910071917
 */

package org.datamanager.kernel;

import java.io.Serializable;

/**
 * EntityValue is a hard class to describe, as it really has no API of its own.
 * It serves as a marker for all the values that an Entity can have in the
 * official releases of Knownspace, in practice, however, methods will use
 * Serializable whereever EntityValue would be the apropriate class, to
 * appease certain nameless developers.
 *
 * @author Benjamin Keil
 * @author Matthew Farrellee
 */
public abstract interface EntityValue extends Serializable
   {
   }














