/**
 * EventGenerator.java
 */

package org.datamanager.kernel;

import org.datamanager.kernel.EventHandler;
import org.datamanager.constraint.EventConstraint;
import org.datamanager.exception.DataManagerException;

/**
 * EventGenerators are just that, able to generate events.  Their
 * natural collaborators are EventHandlers that can subscribe to them
 * using a constraint to filter the events that interest them.
 *
 * @author Matthew Farrellee
 * @author Benjamin Keil
 */
public interface EventGenerator
   {
   public abstract void subscribe(EventHandler handler,
   										 EventConstraint constraint)
   	throws DataManagerException;

   public abstract void unsubscribe(EventHandler handler)
   	throws DataManagerException;

   }
