/**
 * InitializableRunner.java
 */

package org.datamanager.kernel;

import org.datamanager.kernel.Initializable;

/**
 * @author Matthew Farrellee
 */
class InitializableRunner
	implements DataManagerWorker
   {
   private Initializable initializable;

	InitializableRunner()
      {
      // Does nothing right now.
      }

   void reset(Initializable initializable)
      {
      this.initializable = initializable;
      }

   public void process()
      {
      initializable.initialize();

      // Notify something that this thread is now free
      // again.
      }

   public String toString()
      {
      return "InitializableRunner[initializable: " + initializable + "]";
      }

   }
