package org.datamanager.userinterface.cerulean.controller.cluster;

import org.datamanager.userinterface.cerulean.view.component.*;
import org.datamanager.userinterface.cerulean.model.event.*;
import org.datamanager.userinterface.cerulean.model.*;
import org.datamanager.userinterface.cerulean.model.undo.*;
import org.datamanager.userinterface.cerulean.model.data.storage.*;
import org.datamanager.tools.Debug;
import java.awt.*;
public class InterfaceClusterClusterListener extends ClusterAdapter {
	private InterfaceClusterComponent clusterComponent;
	private InterfaceCluster cluster;
	public InterfaceClusterClusterListener(InterfaceClusterComponent clusterComponent) {
		this.clusterComponent = clusterComponent;
		cluster = clusterComponent.getCluster();
		}
	public void clusterAdded(ClusterEvent e) {
		}
	public void clusterRemoved(ClusterEvent e) {
		}
	public void clusterSelected(ClusterEvent e) {
		System.out.println("Reclustering working - sorta");
		if (e.getCluster() == clusterComponent.getCluster()) {
			if (!clusterComponent.isSelected()) {
				clusterComponent.setSelected(true);
				}
			}
		}
	public void clusterUnselected(ClusterEvent e) {
		System.out.println("Reclustering working - sorta");
		if (e.getCluster() == clusterComponent.getCluster()) {
			if (clusterComponent.isSelected()) {
				clusterComponent.setSelected(false);
				}
			}
		}
	public void entitiesAddedToCluster(ClusterContentEvent e) {
		if (e.getCluster() == cluster) {
			InterfaceEntityList entities = e.getEntities();
			if (e.getSource()!=InterfaceUndoManager.getInstance()) {
				AddEntityUndoEdit undoEdit = new AddEntityUndoEdit(entities,cluster);
				InterfaceUndoManager.getInstance().addEdit(undoEdit); 				
				}
			}

		}
	public void entitiesRemovedFromCluster(ClusterContentEvent e) {
		InterfaceEntityList entities = e.getEntities();
		if (e.getCluster() == cluster) {
			if (e.getSource()!= InterfaceUndoManager.getInstance()) {
				RemoveEntityUndoEdit undoEdit = new RemoveEntityUndoEdit(entities,cluster);
				InterfaceUndoManager.getInstance().addEdit(undoEdit);
				}
			}

		}
	public void entitiesReclustered(ClusterReclusteringEvent e) {	
		InterfaceEntityList entities = e.getEntities();
		if (e.getNewCluster() == cluster) {
			Debug.assert("Reclustering in "+cluster.getName());
			if (e.getSource() != InterfaceUndoManager.getInstance()) {
				System.out.println("undo worked - sorta");
				ReclusterEntityUndoEdit undoEdit = new ReclusterEntityUndoEdit(entities,e.getOldClusters(), e.getNewCluster());
				InterfaceUndoManager.getInstance().addEdit(undoEdit);
				}
			}

		}
	}