package org.datamanager.userinterface.cerulean.controller.drop;

import org.datamanager.userinterface.cerulean.view.*;
import org.datamanager.userinterface.cerulean.view.component.*;
import org.datamanager.userinterface.cerulean.model.*;
import org.datamanager.userinterface.cerulean.model.data.storage.InterfaceEntityList;
import org.datamanager.userinterface.cerulean.model.data.transfer.*;

import java.awt.*;
import java.awt.dnd.*;
import java.awt.datatransfer.*;
import java.awt.event.*;
import java.util.Hashtable;
import java.util.List;
import java.util.Iterator;

import java.io.*;
import java.io.IOException;

import javax.swing.*;
import javax.swing.DefaultListModel;

public class BufferDropListener extends InterfaceDropListener {
	private BufferComponent bufferComponent;
	private Buffer buffer;
	public BufferDropListener(BufferComponent bufferComponent) {
		super(bufferComponent);
		this.bufferComponent = bufferComponent;
		buffer = bufferComponent.getBuffer();
		}

	public void performDropAction(InterfaceEntityList entities,
				 InterfaceEntityComponent selectedEntity,
				 DropTargetDropEvent event) {
		Point point = event.getLocation();
		for (int i = 0; i < entities.size(); i++) {
			entities.elementAt(i).setMoved(this, point.x, point.y);
			}
		buffer.reclusterEntities(entities);
		}
	}
