package org.datamanager.userinterface.cerulean.controller.drop;
import org.datamanager.userinterface.cerulean.view.*;
import org.datamanager.userinterface.cerulean.view.component.*;
import org.datamanager.userinterface.cerulean.model.*;
import org.datamanager.userinterface.cerulean.model.data.storage.InterfaceEntityList;
import org.datamanager.userinterface.cerulean.model.data.transfer.*;

import java.awt.*;
import java.awt.dnd.*;
import java.awt.datatransfer.*;
import java.awt.event.*;
import java.util.Hashtable;
import java.util.List;
import java.util.Iterator;

import java.io.*;
import java.io.IOException;

import javax.swing.*;

public class InterfaceDropListener implements DropTargetListener {
	private DropTarget dropTarget;
	private String localFlavor;
	private DragSource dragSource;
	private JComponent component;
	private DataFlavor supportedDataFlavor;
	public InterfaceDropListener(JComponent component) {
		this.component = component;
		localFlavor = DataFlavor.javaJVMLocalObjectMimeType +
			"; class=org.datamanager.userinterface.cerulean.view.component.InterfaceEntityComponent";
		dropTarget = new DropTarget(component, this);
		dragSource = DragSource.getDefaultDragSource();

		}

	public void dragEnter (DropTargetDragEvent event) {
		//System.out.println("accepting drag");
		event.acceptDrag(DnDConstants.ACTION_MOVE);
		}

	public void dragExit (DropTargetEvent event) {
		//System.out.println( "dragExit");
		}

	public void dragOver (DropTargetDragEvent event) {
		Point cursorLocation = event.getLocation();
		if (component.contains(cursorLocation.x, cursorLocation.y)) {
			//System.out.println("dragOver in dropper");
			}
		else {
			//System.out.println("dragOver in Abyss");
			//event.rejectDrag();
			}
		}

	public void drop(DropTargetDropEvent event) {
		//System.out.println(event.getDropAction());  
		Transferable transferable = event.getTransferable();
		//Transferable transferable = null;
		// we accept only Strings
		//System.out.println("dropped2");
		DataFlavor[] dataFlavors = transferable.getTransferDataFlavors();
		for (int i = 0; i <= dataFlavors.length - 1; i++) {
			System.out.println(dataFlavors[i].getMimeType());
			}
		try {
			supportedDataFlavor = new DataFlavor(localFlavor);
			}
		catch (ClassNotFoundException e) {
			System.out.println("Can't find" + e.getMessage());
			System.out.println("" + e.getMessage());
			e.printStackTrace(System.out);
			}
		if (transferable.isDataFlavorSupported(supportedDataFlavor)) {        	
			System.out.println("this is not printing I have no idea why");
	           	event.acceptDrop(DnDConstants.ACTION_MOVE);
			event.dropComplete(true);
			InterfaceEntityComponent entity = null;
			//InterfaceEntityComponent entities;
			try {
				entity = (InterfaceEntityComponent)transferable.getTransferData(supportedDataFlavor);
				System.out.println(entity.getName());
				//event.getDropTargetContext().dropComplete(true);
				}
			catch (UnsupportedFlavorException e) {
				System.out.println("" + e.getMessage());
				e.printStackTrace(System.out);
				}
			catch (IOException e) {
				System.out.println("" + e.getMessage());
				e.printStackTrace(System.out);
				}
			InterfaceEntityManager manager = InterfaceEntityManager.getInstance();
			InterfaceEntityList list = manager.getGroupedEntities();
			performDropAction(list, entity, event);			
			System.out.println("probably won't print this in InterfaceDropListener");
			}
		else{
			System.out.println("not supported");
			event.rejectDrop();
			}
		}
	public void dropActionChanged ( DropTargetDragEvent event ) {
		}
	public void performDropAction(InterfaceEntityList list, InterfaceEntityComponent entity, DropTargetDropEvent event) {
		System.out.println("performing drop action");
		}
	public void performDropAction(InterfaceEntityComponent component, DropTargetDropEvent event) {
		System.out.println("performing drop action");
		}
	}