package org.datamanager.userinterface.cerulean.controller.entity;

import java.util.EventListener;
import org.datamanager.userinterface.cerulean.view.*;
import org.datamanager.kernel.*;
import org.datamanager.userinterface.cerulean.controller.*;
import org.datamanager.userinterface.cerulean.model.*;
import org.datamanager.userinterface.cerulean.model.event.*;
import org.datamanager.userinterface.cerulean.view.component.*;
import org.datamanager.userinterface.cerulean.model.data.transfer.*;

public class InterfaceEntityManagerEntityListener extends EntityAdapter {
	private InterfaceEntityManager entityManager;
	public InterfaceEntityManagerEntityListener(InterfaceEntityManager entityManager) {
		this.entityManager = entityManager;
		}
	public void entityCreated(EntityEvent e) {
		InterfaceEntity entity = e.getEntity();
		if (entity.isAttributeAttached("content-source")) {
			EntityValue value =  entity.getAttribute("content-source").getValue();
			String source = value.toString();
			if (source.equals("news")) {
				NewsEntityComponent component = new NewsEntityComponent(entity);
				}
			else if (source.equals("www")) {
				HTMLEntityComponent component = new HTMLEntityComponent(entity);
				}
			else if (source.equals("email")) {
				EmailEntityComponent component = new EmailEntityComponent(entity);
				}
			else {
				InterfaceEntityComponent component = new InterfaceEntityComponent(entity);
				}
			}
		else {
			InterfaceEntityComponent component = new InterfaceEntityComponent(entity);
			}
		}
	}

