package org.datamanager.userinterface.cerulean.controller.mouse;

import org.datamanager.userinterface.cerulean.view.*;
import org.datamanager.userinterface.cerulean.view.component.*;
import org.datamanager.userinterface.cerulean.controller.*;
import org.datamanager.userinterface.cerulean.model.*;
import org.datamanager.userinterface.cerulean.model.menu.*;
import org.datamanager.userinterface.cerulean.model.data.transfer.*;

import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import java.awt.dnd.*;
import javax.swing.*;
import java.awt.geom.*;
import java.io.*;
public class InterfaceEntityMouseListener implements MouseListener {
	private InterfaceEntityComponent entityComponent;
	private InterfaceEntityPopupMenu popupMenu;
	private InterfaceEntity entity;
	private InterfaceEntityManager manager;
	public InterfaceEntityMouseListener (InterfaceEntityComponent entityComponent) {
		this.entityComponent = entityComponent;
		entity = entityComponent.getInterfaceEntity();
		manager = InterfaceEntityManager.getInstance();
		}
	//store the position of the initial 
	public void mousePressed(MouseEvent e) {
		if (e.isShiftDown()) {
			if (manager.getGroupedEntities().contains(entity)) {
				manager.removeFromGroupedEntities(entity);
				}
			else manager.addToGroupedEntities(entity);
			}
		else if (e.isPopupTrigger()) {
			popupMenu = new InterfaceEntityPopupMenu(entityComponent);
			popupMenu.show(entityComponent, e.getX(), e.getY());
			}
 		else if (!manager.getGroupedEntities().contains(entity)) {
			manager.setAsSelectedEntity(entity);
			}

		}
	public void mouseReleased(MouseEvent e) {
		if (e.isPopupTrigger()) {
			if (popupMenu == null) {
				popupMenu = new InterfaceEntityPopupMenu(entityComponent);
				}
			popupMenu.show(entityComponent, e.getX(), e.getY());
			}
		System.out.println("released");
		}
	public void mouseEntered(MouseEvent e) {
		}
	public void mouseClicked(MouseEvent e) {
		entityComponent.requestFocus();
		System.out.println("mouseClicked");
		if (e.getClickCount() == 2) {
			entity.setOpened(entityComponent.getParent());
			System.out.println("opened");
			}
		}
	public void mouseExited(MouseEvent e) {
		}
	}
