/*
class org.datamanager.userinterface.cerulean.model.Abyss
KnownSpace: Cerulean

Authors:
~~~~~~~~
Gordon Murphy, gpmurphy@indiana.edu
Bryan Dawson, bdawson@indiana.edu
*/

package org.datamanager.userinterface.cerulean.model;
import org.datamanager.userinterface.cerulean.view.*;
import org.datamanager.userinterface.cerulean.controller.drop.*;
import org.datamanager.userinterface.cerulean.controller.entity.*;
import org.datamanager.userinterface.cerulean.model.*;
import org.datamanager.userinterface.cerulean.model.data.storage.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.awt.geom.*;
import java.io.*;
/**
 *
 * The abyss is "trash can". Items can be added to the abyss, 
 * where they are held unto disposed of.
 *
 * @see Circle
 * @see CircleManager
 * @see InterfaceEntityManager
 * @see CircleIcon
 * @see AbyssDropListener
 *
 * @version 1.0
 * @author Gordon Murphy, gpmurphy@indiana.edu
 * @author Bryan Dawson, bdawson@indiana.edu 
 */

////////////////////////////////////////////////////////////////////////////////
public class Abyss extends InterfaceCluster implements Serializable {
	/**
	 * Creates a new Abyss with default settings
	 */
	public static final int MAX_ENTITIES_IN_ABYSS = 10;
	public Abyss() {
		super("Abyss");
		}
	public void addEntities(Object source, InterfaceEntityList entities, boolean isEventFired) {
		super.addEntities(source, entities, isEventFired);
		}
	public void removeEntities(InterfaceEntityList list, boolean isEventFired) {
		super.removeEntities(list, isEventFired);
		}
	public void clearAbyss() {
		}
	}