package org.datamanager.userinterface.cerulean.model.event;

import java.util.EventListener;

/**
 * EventListener is the interface that all class that wish
 * to listen for EntityEvents must implement.
 */

public interface EntityListener extends EventListener {
/**
 * Called when an entity is created.
 */
	public void entityCreated(EntityEvent e);
/**
 * Called when an entity is selected.
 */
	public void entitySelected(EntityEvent e);
/**
 * Called when an entity is unselected.
 */
	public void entityUnselected(EntityEvent e);
/**
 * Called when an entity is opened.
 */
	public void entityOpened(EntityEvent e);
/**
 * Called when an entity is attached.
 */
	public void entityAttached(EntityBoundEvent e);
/**
 * Called when an entity is detached.
 */
	public void entityDetached(EntityBoundEvent e);
/**
 * Called when an entity is moved.
 */
	public void entityMoved(EntityMovedEvent e);
/**
 * Called when an entity is modified.
 */
	public void entityModified(EntityEvent e);
	}