/*
class org.datamanager.userinterface.cerulean.model.kernel.KernelProxy
KnownSpace: Cerulean

Authors:
~~~~~~~~
Gordon Murphy, gpmurphy@indiana.edu
Bryan Dawson, bdawson@indiana.edu
*/
////////////////////////////////////////////////////////////////////////////////

package org.datamanager.userinterface.cerulean.model.kernel;

import org.datamanager.exception.DataManagerException;
import org.datamanager.kernel.Entity;
import org.datamanager.kernel.Pool;

////////////////////////////////////////////////////////////////////////////////
/**
 * Adds an entity the kernel's pool.
 * <strong>Note: This thread will only work when run within the kernel on an 
 * approved thread.</strong>
 */
public class AddEntityWorker extends InterfaceWorker {
	private Entity entity;

////////////////////////////////////////////////////////////////////////////////
/**
 * Create a new Worker with the given entity
 * @param entity the entity to add to the pool.
 */
	public AddEntityWorker(Entity entity) {
		this.entity = entity;
		}
	protected Object construct() {
		try {
			Pool.getDefaultPool().add(entity);
			}
		catch (DataManagerException e) {
			e.printStackTrace();
			}
		return null;
		}
	}
