//////////////////////////////////////////////////////////////
package org.datamanager.userinterface.cerulean.model.kernel;

import org.datamanager.userinterface.cerulean.Cerulean;
import org.datamanager.userinterface.cerulean.view.component.*;
import org.datamanager.userinterface.cerulean.model.data.storage.*;
import org.datamanager.userinterface.cerulean.model.*;
import org.datamanager.kernel.*;
import org.datamanager.tools.*;
import org.datamanager.exception.*;
import org.datamanager.constraint.*;
import org.datamanager.event.*;
import java.io.*;

////////////////////////////////////////////////////////////////////////////////
/**
 * Attaches an entity as an attribute to another entity.
 * <strong>Note: This thread will only work when run within the kernel on an 
 * approved thread.</strong>
 */
public class AttachEntityWorker extends InterfaceWorker {
	private Entity base, attribute;
/**
 * Attach attribute as an attribute to base
 * @param base the base entity that will receive the attribute
 * @param attribute the entity that will attach itself
 */	
	public AttachEntityWorker(Entity base, Entity attribute) {
		this.base = base;
		this.attribute = attribute;
		}
	protected Object construct() {
		try {
			base.attach(attribute);
			}
		catch (DataManagerException e) {
			e.printStackTrace();
			}
		return null;
		}
	}
