//////////////////////////////////////////////////////////////
package org.datamanager.userinterface.cerulean.model.kernel;

import org.datamanager.exception.DataManagerException;
import org.datamanager.kernel.Entity;
import org.datamanager.kernel.Pool;
//////////////////////////////////////////////////////////////
/**
 * Creates a new entity and adds it to the pool.
 * A call to get() will retrieve the entity as an Object.
 * <strong>Note: This thread will only work when run within the kernel on an 
 * approved thread.</strong>
 */
public class CreateEntityWorker extends InterfaceWorker {
	private String name;
/**
 * Creates a worker that makes a new entity and adds it to the pool.
 * @param the name of the new entity
 */
	public CreateEntityWorker(String name) {
		this.name = name;
		}
	protected Object construct() {
		Entity entity = null;
		try {
			entity = Entity.create(name);
			Pool.getDefaultPool().add(entity);
			}
		catch (DataManagerException e) {
			e.printStackTrace();
			}
		return entity;
		}
	}
