//////////////////////////////////////////////////////////////
package org.datamanager.userinterface.cerulean.model.kernel;

import org.datamanager.exception.DataManagerException;
import org.datamanager.kernel.Entity;
import org.datamanager.kernel.Pool;
import org.datamanager.kernel.EntityValue;
import org.datamanager.passiveentityvalue.NullEntityValue;

////////////////////////////////////////////////////////////////////////////////
/**
 * Retrieves the value of an entity.
* A call to get() will retrieve the EntityValue as an Object.
 * <strong>Note: This thread will only work when run within the kernel on an 
 * approved thread.</strong>
 */
public class GetEntityValueWorker extends InterfaceWorker {
	private Entity entity;
////////////////////////////////////////////////////////////////////////////////
/**
 * Creates a worker to get the value of an entity.
 * @param entity the entity to retrieve the value of
 */
	public GetEntityValueWorker(Entity entity) {
		this.entity = entity;
		}
	protected Object construct() {
		EntityValue value = null;
		try {
			value = entity.getValue();
			}
		catch (DataManagerException e) {
			e.printStackTrace();
			}
		if  (value == null) {
			value = new NullEntityValue();
			}
		return value;
		}
	}
