//////////////////////////////////////////////////////////////
package org.datamanager.userinterface.cerulean.model.kernel;

import org.datamanager.exception.DataManagerException;
import org.datamanager.kernel.Entity;
import org.datamanager.kernel.Pool;

////////////////////////////////////////////////////////////////////////////////
/**
 * Retrieves the name (not the interface name) of an entity.
 * A call to get() will retrieve the String (name) as an Object.
 * <strong>Note: This thread will only work when run within the kernel on an 
 * approved thread.</strong>
 */
public class GetNameWorker extends InterfaceWorker {
	private Entity entity;
/**
 * Creates a worker to get the name of an entity.
 * @param entity the entity to get the name of
 * @param constraint the constraint to match
 */
	public GetNameWorker(Entity entity) {
		this.entity = entity;
		}
	protected Object construct() {
		String name = null;
		try {
			name = entity.getName();
			}
		catch (DataManagerException e) {
			e.printStackTrace();
			}
		return name;
		}
	}
