//////////////////////////////////////////////////////////////
package org.datamanager.userinterface.cerulean.model.kernel;

import org.datamanager.exception.DataManagerException;
import org.datamanager.kernel.Entity;
import org.datamanager.kernel.Pool;

////////////////////////////////////////////////////////////////////////////////
/**
 * Removes an entity from the kernel's pool.
 * <strong>Note: This thread will only work when run within the kernel on an 
 * approved thread.</strong>
 */

public class RemoveEntityWorker extends InterfaceWorker {
	private Entity entity;

////////////////////////////////////////////////////////////////////////////////
/**
 * Create a new Worker that removes the entity from the pool
 * @param entity the entity to remove from the pool.
 */
	public RemoveEntityWorker(Entity entity) {
		this.entity = entity;
		}
	protected Object construct() {
		try {
			Pool.getDefaultPool().remove(entity);
			}
		catch (DataManagerException e) {
			e.printStackTrace();
			}
		return null;
		}
	}
