//////////////////////////////////////////////////////////////
package org.datamanager.userinterface.cerulean.model.kernel;

import org.datamanager.exception.DataManagerException;
import org.datamanager.kernel.Entity;
import org.datamanager.kernel.Pool;
import org.datamanager.constraint.EventConstraint;
import org.datamanager.kernel.EventHandler;
////////////////////////////////////////////////////////////////////////////////
/**
 * Subscribes a handler to all events matching the given constraint.  
 * A call to get() will retrieve the value of the operation
 * <strong>Note: This thread will only work when run within the kernel on an 
 * approved thread.</strong>
 */

public class SubscriptionWorker extends InterfaceWorker {
	private EventConstraint constraint;
	private EventHandler handler;
/**
 * Creates a worker to subscribe the handler to events.
 * @param constraint the constraint describing an event.
 * @param handler the EventHandler to be subscribed
 */
	public SubscriptionWorker(EventConstraint constraint, EventHandler handler) {
		this.constraint = constraint;
		this.handler = handler;
		}
	protected Object construct() {
		try {
			Pool.getDefaultPool().subscribe(handler, constraint);
			}
		catch (DataManagerException e) {
			e.printStackTrace();
			}
		return null;
		}
	}
