package org.datamanager.userinterface.cerulean.model.menu;

import org.datamanager.userinterface.cerulean.view.*;
import org.datamanager.userinterface.cerulean.view.component.*;
import org.datamanager.userinterface.cerulean.controller.action.*;
import org.datamanager.userinterface.cerulean.model.*;
import org.datamanager.userinterface.cerulean.model.menu.*;
import org.datamanager.userinterface.cerulean.model.event.*;
import org.datamanager.userinterface.cerulean.model.data.transfer.*;
import org.datamanager.userinterface.cerulean.model.data.storage.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;

/**
 * A popup menu that the stage displays.
 * Currently, they display the following:<br>
 * <ul>
 * <li>Engage All Clusters</li>
 * <li>Disengage All Clusters</li>
 * <li>Engage Cluster (bring out another menu displaying clusters to engage)</li>
 * <li>Personalize</li>
 * <li>Show All Labels</li>
 */

public class BufferPopupMenu extends InterfacePopupMenu {
	public BufferPopupMenu(BufferComponent buffer) {
		super();
		JSeparator separator = new JSeparator();
		EngageAllClustersAction engageAction = new EngageAllClustersAction();
		JMenuItem engage = new JMenuItem();
		engage.addActionListener(engageAction);
		engage.setText("Engage All Clusters");
		add(engage);

		DisengageAllClustersAction disengageAction = new DisengageAllClustersAction();
		JMenuItem disengage = new JMenuItem();
		disengage.addActionListener(disengageAction);
		disengage.setText("Disengage All Clusters");
		add(disengage);

		InterfaceClusterCheckBoxMenu clusterMenu = new ClusterSelectionMenu("Engage Cluster");
		add(clusterMenu);

		add(separator);

		JMenuItem personalize = new JMenuItem("Personalize");
		personalize.addActionListener(new PersonalizeAction(buffer));
		add(personalize);
		}
	}//end class