package org.datamanager.userinterface.cerulean.model.menu;

import org.datamanager.userinterface.cerulean.view.*;
import org.datamanager.userinterface.cerulean.view.component.*;
import org.datamanager.userinterface.cerulean.model.*;
import org.datamanager.userinterface.cerulean.model.event.*;
import org.datamanager.userinterface.cerulean.model.data.transfer.*;
import org.datamanager.userinterface.cerulean.model.data.storage.*;
import org.datamanager.userinterface.cerulean.controller.action.EngageClusterAction;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;

/**
 * A Menu that displays a list of clusters, checked if they are selected,
 * and unchecked if they are unselected.  Checking a cluster results in that
 * cluster being engaged.
 *
 * @see InterfaceCluster
 * @see InterfaceClusterCheckBoxMenu
 *
 * @author Gordon Murphy (gpmurphy@indiana.edu)
 * @author Bryan Dawson (bdawson@indiana.edu)
 */

public class ClusterSelectionMenu extends InterfaceClusterCheckBoxMenu {
/**
 * Create a new ClusterSelectionMenu with the name set to text.
 * @param text the name of the menu
 */
	public ClusterSelectionMenu(String text) {
		super(text);
		}
	public void addListener(InterfaceClusterCheckBoxMenuItem item) {
		super.addListener(item);
		EngageClusterAction action;
		action = new EngageClusterAction(item.getCluster(), item);
		item.addActionListener(action);
		}
	}