package org.datamanager.userinterface.cerulean.model.menu;

import org.datamanager.userinterface.cerulean.view.*;
import org.datamanager.userinterface.cerulean.view.component.*;
import org.datamanager.userinterface.cerulean.model.*;
import org.datamanager.userinterface.cerulean.model.event.*;
import org.datamanager.userinterface.cerulean.model.data.transfer.*;
import org.datamanager.userinterface.cerulean.model.data.storage.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * A JMenuItem representing a specific cluster.  The name is set to
 * the name of the cluster.
 * 
 * @see InterfaceCluster
 * @see JMenuItem
 *
 * @author Gordon Murphy (gpmurphy@indiana.edu)
 * @author Bryan Dawson (bdawson@indiana.edu)
 */

public class InterfaceClusterCheckBoxMenuItem extends JCheckBoxMenuItem {
	private InterfaceCluster cluster;
	private Action action;
/**
 * Create a new menu item representing cluster.
 * @param cluster the cluster this menu item will represent
 */
	public InterfaceClusterCheckBoxMenuItem(InterfaceCluster cluster) {
		super();
		this.cluster = cluster;
		setText(cluster.getName());
		}
	public InterfaceCluster getCluster() {
		return cluster;
		}
	}