package org.datamanager.userinterface.cerulean.model.menu;

import org.datamanager.userinterface.cerulean.view.*;
import org.datamanager.userinterface.cerulean.view.component.*;
import org.datamanager.userinterface.cerulean.model.*;
import org.datamanager.userinterface.cerulean.model.event.*;
import org.datamanager.userinterface.cerulean.model.data.transfer.*;
import org.datamanager.userinterface.cerulean.model.data.storage.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * Essentially a JMenuItem whose name field is set to the name
 * of the cluster.  Also, the cluster may be retrieved.
 */
public class InterfaceClusterMenuItem extends JMenuItem {
	private InterfaceCluster cluster;
	private Action action;
/**
 * Create a new menu item containing the cluster.
 * @param cluster the cluster the menu item represents.
 */
	public InterfaceClusterMenuItem(InterfaceCluster cluster) {
		super();
		this.cluster = cluster;
		setText(cluster.getName());
		}
/**
 * Retrieve the cluster this represents.
 * @return an InterfaceCluster
 */
	public InterfaceCluster getCluster() {
		return cluster;
		}
	}