package org.datamanager.userinterface.cerulean.model.menu;

import org.datamanager.userinterface.cerulean.view.*;
import org.datamanager.userinterface.cerulean.view.component.*;
import org.datamanager.userinterface.cerulean.controller.action.*;
import org.datamanager.userinterface.cerulean.model.*;
import org.datamanager.userinterface.cerulean.model.event.*;
import org.datamanager.userinterface.cerulean.model.data.transfer.*;
import org.datamanager.userinterface.cerulean.model.data.storage.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * A popup menu that clusters display.
 * Currently, they display the following:<br>
 * <ul>
 * <li>Engage Only This Cluster</li>
 * <li>Engage All But This Cluster</li>
 * <li>Dissolve Cluster</li>
 * <li>Create New Entity</li>
 */

public class InterfaceClusterPopupMenu extends InterfacePopupMenu {
	InterfaceClusterComponent cluster;
	JMenuItem createNewEntity;
	public InterfaceClusterPopupMenu(InterfaceClusterComponent cluster) {
		super();
		this.cluster = cluster;

		EngageOnlyThisClusterAction selectAction = new EngageOnlyThisClusterAction(cluster.getCluster());
		JMenuItem engage = new JMenuItem();
		engage.addActionListener(selectAction);
		engage.setText("Engage Only This Cluster");
		add(engage);

		EngageAllButThisClusterAction disengageAction = new EngageAllButThisClusterAction(cluster.getCluster());
		JMenuItem disengage = new JMenuItem();
		disengage.addActionListener(disengageAction);
		disengage.setText("Engage All But This Cluster");
		add(disengage);

		RemoveClusterAction removeAction = new RemoveClusterAction(cluster.getCluster());
		JMenuItem remove = new JMenuItem("Dissolve Cluster");
		remove.addActionListener(removeAction);
		remove.setEnabled(cluster.getCluster().isDissolvable());
		add(remove);

		add(new JSeparator());

		createNewEntity = new JMenuItem("Create New Entity");
		createNewEntity.addActionListener(new CreateNewEntityAction(cluster.getCluster()));
		add(createNewEntity);
		}
	}
