package org.datamanager.userinterface.cerulean.model.personalize;

import org.datamanager.userinterface.cerulean.view.*;
import org.datamanager.userinterface.cerulean.model.*;
import org.datamanager.userinterface.cerulean.model.event.*;
import org.datamanager.userinterface.cerulean.model.data.transfer.*;
import org.datamanager.userinterface.cerulean.model.data.storage.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.geom.*;

/**
 * A panel that allows a name to be chosen for a given personalizeable 
 * object.
 *
 * @see Personalizeable
 * @see Personalizer
 *
 * @author Gordon Murphy (gpmurphy@indiana.edu)
 * @author Bryan Dawson (bdawson@indiana.edu)
 */

public class NameChooserPanel extends JPanel implements ActionListener {
	private JTextField nameField;
	private Personalizable entity;
	public NameChooserPanel(Personalizable entity) {
		super();
		setBorder(BorderFactory.createTitledBorder("Alter the Name"));
		this.entity = entity;
		
		nameField = new JTextField(30);
		add(new JLabel("Entity Name"));
		add(nameField);
		nameField.addActionListener(this);
		nameField.setText(entity.getName());
		}
	public void actionPerformed(ActionEvent e) {
		entity.setName(nameField.getText());
		}
	}