package org.datamanager.userinterface.cerulean.sounds;

import java.util.Hashtable;
import java.net.URL;
import java.net.MalformedURLException;
import java.applet.Applet;
import java.applet.AudioClip;
/**
 *Load and store a collection of sounds and play them given their names.
 *This loads and plays sounds through java.applet.Applet, which was not very 
 *well developed by Sun, so a few extra steps had to be taken. For details
 *see SoundRequestHandler
 *
 *@author Gregory Rawlins (rawlins@cs.indiana.edu)
 *
 *@see SoundRequestHandler
 *@see AudioClip
 *@see URL
 */ 

public class Orchestra
        {
        /*
        Load and store a collection of sounds
        and play them given their names.
        */

        private URL soundBaseURL;     //location of sounds to be loaded
        private Hashtable soundTable; //loaded sounds and their names

        public Orchestra(URL soundBaseURL)
                {
                this.soundBaseURL = soundBaseURL;
                soundTable = new Hashtable();
                }

        public void load(String soundName)
                {
                URL soundURL = null;
                try { soundURL = new URL(soundBaseURL, soundName); }
                catch (MalformedURLException ignored) {}

                AudioClip audioClip = Applet.newAudioClip(soundURL);
                soundTable.put(soundName, audioClip);
                }

        public void play(String soundName)
                {
                AudioClip audioClip = (AudioClip) soundTable.get(soundName);

                if (audioClip != null)
                        audioClip.play();
                }
        }
