/**
class org.datamanager.userinterface.cerulean.view.tree.DisplayFrame

Authors:
~~~~~~~~
Bryan Dawson, bdawson@indiana.edu
Gordon Murphy, gpmurphy@indiana.edu

Description:
~~~~~~~~~~~~
This class is used my the EntityNode class to display the contents of their 
entity.  It uses overriden methods to display all of the currently accepted
Knownspace EntityValues.  The EntityNode must pass the EntityValue of it's 
Entity to be displayed.

Methods:
~~~~~~~~
public DisplayFrame()
	create a DisplayFrame.
(There will be many overriden versions of this method in the future)
public void display(EntityValue)	 
	Uses this DisplayFrame's JEditorPane to display the EntityValue. 
	Currently does nothing but display "Not Yet Ready".
	
Other Classes to see:
~~~~~~~~~~~~~~~~~~~~~
org.datamanager.kernel.Entity
org.datamanager.kernel.EntityValue
org.datamanager.userinterface.cerulean.model.EntityNode

**/
///////////////////////////////////////////////////////////////////////

package org.datamanager.userinterface.cerulean.view;

import org.datamanager.kernel.EntityValue;
import org.datamanager.passiveentityvalue.BooleanEntityValue;
import org.datamanager.passiveentityvalue.NumericEntityValue;
//import org.datamanager.passiveentityvalue.CharacterEntityValue;
import java.awt.BorderLayout;
import javax.swing.JFrame;
import javax.swing.JEditorPane;

public class DisplayFrame extends JFrame
   {
   //This does the actual displaying of the EntityValues
   private JEditorPane editor;
   
   ////////////////////////////////////////////////////////////
   /*Create the JEditorPane and setup the frame
   */
   public DisplayFrame()
      {
      super("Entity Contains....");
      editor = new JEditorPane();
      getContentPane().setLayout(new BorderLayout());
      getContentPane().add(editor, BorderLayout.CENTER);
     
      this.setSize(400,200);
      }
   ////////////////////////////////////////////////////////////
   /*In the future this method will be overriden to display
   / all of the approved EntityValue's.  Currently, however, 
   / it just displays  "Not Yet Ready"
   */
   public void display(NumericEntityValue value)
      {
      editor.setText(value.toString());
      this.show();
      }
/*Not here yet
   public void display(CharacterEntityValue value)
      {
      editor.setText(value.toString());
      this.show();
      }
*/	
   public void display(EntityValue value)
      {
      editor.setText("Not Yet Ready...right now just does toString() :\n"+
      				value.toString());
      this.show();
      }
   }            
