package org.datamanager.userinterface.cerulean.view.component;

import org.datamanager.userinterface.cerulean.view.icon.*;
import org.datamanager.userinterface.cerulean.view.layout.*;
import org.datamanager.userinterface.cerulean.view.*;
import org.datamanager.userinterface.cerulean.model.*;
import org.datamanager.userinterface.cerulean.model.data.transfer.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.Vector;
import java.io.Serializable;

public class CRootPane extends JPanel {
	protected JComponent glassPane;
	protected JComponent entityPane;
	protected JComponent abyssPane;
	protected JComponent tabPane;
	protected JComponent stagePane;
	protected JComponent bufferPane;
	protected JComponent buttonPane;
	public CRootPane() {	
		setGlassPane(createGlassPane());
		setTabPane(createLayeredPane());
		setStagePane(createLayeredPane());
		setBufferPane(createLayeredPane());
		setAbyssPane(createLayeredPane());
		//setButtonPane(createLayeredPane());	
		setLayout(createRootLayout());
		}
	protected JLayeredPane createLayeredPane() {
		JLayeredPane p = new JLayeredPane();
		p.setName(this.getName()+".layeredPane");
		return p;
		}
	public String getName() {
		return "CRootPane";
		}
	protected JComponent createGlassPane() {
		JComponent glassPane = new JPanel();
		glassPane.setVisible(false);
		glassPane.setOpaque(false);
		return glassPane;
		}
	public void setAbyssPane(JComponent pane) {
      	if (pane == null)
            	throw new IllegalComponentStateException("abyssPane cannot be set to null.");
		if (abyssPane != null && abyssPane.getParent() == this) {
			this.remove(abyssPane);
			}
		abyssPane = pane;
		abyssPane.setVisible(true);
		abyssPane.setOpaque(false);
		add(abyssPane, -1);
		//add(abyssPane);
		}
	public JComponent getAbyssPane() {
		return abyssPane;
		}
	public void setButtonPane(JComponent pane) {
      	if (pane == null)
            	throw new IllegalComponentStateException("tabPane cannot be set to null.");
		if (buttonPane != null && buttonPane.getParent() == this) {
			this.remove(buttonPane);
			}
		buttonPane = pane;
		buttonPane.setVisible(true);
		buttonPane.setOpaque(false);
		add(buttonPane, -1);
		}
	public JComponent getButtonPane() {
		return buttonPane;
		}
	public JComponent getGlassPane() {
		return glassPane;
		}
    public void setGlassPane(JComponent glass) {
        if (glass == null) {
            throw new NullPointerException("glassPane cannot be set to null.");
        }

        boolean visible = false;
        if (glassPane != null && glassPane.getParent() == this) {
            this.remove(glassPane);
            visible = glassPane.isVisible();
        }
        glass.setVisible(visible);
        glassPane = glass;
        this.add(glassPane, 0);
        if (visible) {
            repaint();
        }
    }
	public void setTabPane(JComponent pane) {
      	if (pane == null)
            	throw new IllegalComponentStateException("tabPane cannot be set to null.");
		if (tabPane != null && tabPane.getParent() == this) {
			this.remove(tabPane);
			}
		tabPane = pane;
		tabPane.setVisible(true);
		tabPane.setOpaque(false);
		add(tabPane, -1);
		}
	public JComponent getTabPane() {
		return tabPane;
		}
	public void setBufferPane(JComponent pane) {
      	if (pane == null)
            	throw new IllegalComponentStateException("bufferPane cannot be set to null.");
		if (bufferPane != null && bufferPane.getParent() == this) {
			this.remove(bufferPane);
			}
		bufferPane = pane;
		bufferPane.setVisible(true);
		bufferPane.setOpaque(false);
		add(bufferPane, -1);
		}
	public JComponent getBufferPane() {
		return bufferPane;
		}
	public void setStagePane(JComponent pane) {
      	if (pane == null)
            	throw new IllegalComponentStateException("stagePane cannot be set to null.");
		if (stagePane != null && stagePane.getParent() == this) {
			this.remove(stagePane);
			}
		stagePane = pane;
		stagePane.setVisible(true);
		stagePane.setOpaque(false);
		add(stagePane, -1);
		//add(stagePane);
		}
	public JComponent getStagePane() {
		return stagePane;
		}
	protected LayoutManager createRootLayout() {
      	return new CRootLayout(this);
		}
	public boolean isValidateRoot() {
		return false;
		}

    protected void addImpl(Component comp, Object constraints, int index) {
        super.addImpl(comp, constraints, index);
        
        /// We are making sure the glassPane is on top. 
        if(glassPane != null 
            && glassPane.getParent() == this
            && getComponent(0) != glassPane) {
            add(glassPane, 0);
        }
    } 
	public Component findComponentAt(int x, int y) {
		if (!contains(x, y)) {
			return null;
			}
		int ncomponents = getComponentCount();
		Component component[] = getComponents();
		for (int i = 0 ; i < ncomponents ; i++) {
			Component comp = component[i];
			if (comp != null) {
				if (comp == glassPane) {  // don't use equals()
					continue;
					}
				else if (comp instanceof Container) {
					comp = ((Container)comp).findComponentAt(x - comp.getX(), y - comp.getY());
					}
				else {
					comp = comp.getComponentAt(x - comp.getX(), y - comp.getY());
					}
				if (comp != null && comp.isVisible()) {
      	            	return comp;
					}
				}
			}
		return this;
		}
	}
