package org.datamanager.userinterface.cerulean.view.component;
import org.datamanager.userinterface.cerulean.view.icon.*;

import org.datamanager.userinterface.cerulean.view.*;
import org.datamanager.userinterface.cerulean.view.viewer.*;
import org.datamanager.userinterface.cerulean.controller.*;
import org.datamanager.userinterface.cerulean.model.*;
import org.datamanager.userinterface.cerulean.model.event.*;
import org.datamanager.userinterface.cerulean.model.data.transfer.*;

import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import java.awt.dnd.*;
import javax.swing.*;
import java.awt.geom.*;
import java.io.*;
import java.awt.font.*;
/**
 * A tooltip that can be shown at any time, positioned over the component that
 * it is a part of. 
 *
 * @see JToolTip
 *
 * @author Gordon Murphy (gpmurphy@indiana.edu)
 */
public class CeruleanToolTip extends JToolTip {
	private String labelText;
	private boolean isDisplayed;
	JComponent caller;
	public CeruleanToolTip() {
		this("");
		}
	public CeruleanToolTip(String text) {
		super();
		setTipText(text);
		setSize(getPreferredSize());
		}
	public void paintComponent(Graphics g) {
		super.paintComponent(g);
		setSize(getPreferredSize());
		}
	public boolean isDisplayed() {
		return isDisplayed;
		}
	public void showLabel(JComponent caller, Point point) {
		isDisplayed = true;
		this.caller = caller;
		ToolTipManager.sharedInstance().unregisterComponent(caller);
		SwingUtilities.convertPoint(caller,point,caller.getRootPane().getLayeredPane());
		Dimension size = getSize();
		setTipText(caller.getToolTipText());
		setSize(getPreferredSize());
		setLocation(point.x,point.y);
		setEnabled(true);
		caller.getRootPane().getLayeredPane().add(this,JLayeredPane.POPUP_LAYER,-1);
		}
	public void hideLabel() {
		Container parent = getParent();
		Rectangle bounds = getBounds();
		if (parent !=null) {
			parent.remove(this);
			parent.repaint(bounds.x,bounds.y,bounds.width,bounds.height);
			}
		isDisplayed = false;
		setEnabled(false);
		ToolTipManager.sharedInstance().registerComponent(caller);
		}
	}