package org.datamanager.userinterface.cerulean.view.component;
import org.datamanager.userinterface.cerulean.view.icon.*;
import org.datamanager.userinterface.cerulean.view.*;
import org.datamanager.userinterface.cerulean.model.*;
import org.datamanager.userinterface.cerulean.model.data.transfer.*;
import org.datamanager.userinterface.cerulean.model.data.storage.InterfaceEntityList;
import org.datamanager.kernel.Entity;
import org.datamanager.tools.Debug;

import org.datamanager.userinterface.cerulean.view.tree.*;
import org.datamanager.userinterface.cerulean.view.undo.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.awt.geom.*;
public class LayeredClusterPanel extends JComponent {
	CRootPane rootPane;
	StagePane clusterPanel;
	public LayeredClusterPanel() {
		addComponentListener(new ComponentAdapter() {
			public void componentResized(ComponentEvent e) {
				repaint();
				System.out.println("resized");
				}
			});

		CircleManager circleManager = CircleManager.getInstance();
		circleManager.setCurrentShape(getDefaultShape());
		setLayout(new BorderLayout());
		rootPane = new CRootPane();
		add(rootPane, BorderLayout.CENTER);	
		clusterPanel = new StagePane();
		CirclePane layer = new CirclePane();
//		layer.setLayout(null);
//		getCRootPane().setLayeredPane(layer);
		ContentPane content = new ContentPane();
		setGlassPane(getGlassPane());
//		setGlassPane(new JPanel());
		getGlassPane().setVisible(false);
		
		setTabPane(new InterfaceClusterPane());
		setStagePane(clusterPanel);
		setBufferPane(new BufferPane());
		setAbyssPane(new AbyssPane());
		//getCRootPane().setButtonPane(new ButtonPane());
		}
	
	protected Shape getDefaultShape() {
		Ellipse2D.Double circle = new Ellipse2D.Double(0,
								0,
								340,
								1000
								);
		return circle;
		}
	///////////////////////////////////////////////////////////////////////
	public JComponent getGlassPane() {
		return getCRootPane().getGlassPane();
		}
	public CRootPane getCRootPane() {
		return rootPane;
		}
	public JRootPane getRootPane() {
		return ((JComponent)getParent()).getRootPane();;
		}

	///////////////////////////////////////////////////////////////////////
	public void setGlassPane(JComponent glassPane) {
		getCRootPane().setGlassPane(glassPane);
		}

	///////////////////////////////////////////////////////////////////////
	public void setStagePane(JComponent layeredPane) {
		CRootPane root = (CRootPane)getCRootPane();
		root.setStagePane(layeredPane);
		}

	///////////////////////////////////////////////////////////////////////
	public StagePane getStagePane() {
		CRootPane root = (CRootPane)getCRootPane();
		return (StagePane)(root.getStagePane());
		}
	///////////////////////////////////////////////////////////////////////
	public void setBufferPane(JComponent bufferPane) {
		CRootPane root = (CRootPane)getCRootPane();
		root.setBufferPane(bufferPane);
		}
	///////////////////////////////////////////////////////////////////////
	public BufferPane getBufferPane() {
		CRootPane root = (CRootPane)getCRootPane();
		return (BufferPane)(root.getBufferPane());
		}
	///////////////////////////////////////////////////////////////////////
	public void setTabPane(JComponent layeredPane) {
		CRootPane root = (CRootPane)getCRootPane();
		root.setTabPane(layeredPane);
		}
	public InterfaceClusterPane getTabPane() {
		CRootPane root = (CRootPane)getCRootPane();
		return (InterfaceClusterPane)(root.getTabPane());
		}
	public AbyssPane getAbyssPane() {
		CRootPane root = (CRootPane)getCRootPane();
		return (AbyssPane)(root.getAbyssPane());
		}
	public void setAbyssPane(JComponent entityPane) {
		//CRootPane root = (CRootPane)getCRootPane();
		getCRootPane().setAbyssPane(entityPane);
		}
	///////////////////////////////////////////////////////////////////////	
	public static void main(String[] arguments) {
		Debug.setTracer(true);
		LayeredClusterPanel c = new LayeredClusterPanel();
		JFrame f = new JFrame();
		JPanel h = new JPanel(new BorderLayout());
		//SplitPane sidePanel = new SplitPane();

		f.addWindowListener(new WindowAdapter() {
		  public void windowClosing(WindowEvent e) {
			  System.exit(0);
			 }
	 	      }
		);

		//f.getGlassPane().setVisible(false);
		f.getContentPane().add(h);
	       
		h.add(c, BorderLayout.CENTER);

		//h.add(sidePanel, BorderLayout.EAST);

		c.getTabPane().addRecommendedCluster();
		InterfaceCluster cluster4 = new InterfaceCluster("Testing");
		c.getTabPane().addCluster(cluster4);
		InterfaceCluster cluster5 = new InterfaceCluster("Testing");
		c.getTabPane().addCluster(cluster5);
		InterfaceCluster cluster6 = new InterfaceCluster("Testing");
		c.getTabPane().addCluster(cluster6);
		InterfaceEntityList list = new InterfaceEntityList();
		for (int i = 0; i<=10; i++) {
		list.addEntity(new InterfaceEntity(Entity.create("Gordon"+i)));
		list.addEntity(new InterfaceEntity(Entity.create("Bryan"+i)));
		list.addEntity(new InterfaceEntity(Entity.create("Matt"+i)));
		list.addEntity(new InterfaceEntity(Entity.create("Caou"+i)));
		list.addEntity(new InterfaceEntity(Entity.create("Alex"+i)));
		list.addEntity(new InterfaceEntity(Entity.create("Gregory"+i)));
		list.addEntity(new InterfaceEntity(Entity.create("Rick"+i)));
		list.addEntity(new InterfaceEntity(Entity.create("Other people"+i)));
		list.addEntity(new InterfaceEntity(Entity.create("Bahadir"+i)));
		list.addEntity(new InterfaceEntity(Entity.create("Mary"+i)));
		}
		c.getTabPane().addSearchCluster();
		c.getTabPane().addCluster("Cerulean Hackers", 145, list);
		c.getTabPane().addCluster("gradient", 45, new GradientPaint(0, 0, Color.lightGray, 50, 50, Color.darkGray));

		JComponent l = (JComponent)c.getGlassPane();
		StageComponent c1 = c.getStagePane().getStage();

		f.setSize(360, 360);
		//c.addTab("hi");
		f.show();
		}
	}