package org.datamanager.userinterface.cerulean.view.component;

import org.datamanager.userinterface.cerulean.view.icon.*;

import org.datamanager.userinterface.cerulean.view.*;
import org.datamanager.userinterface.cerulean.view.viewer.*;
import org.datamanager.userinterface.cerulean.controller.drop.*;
import org.datamanager.userinterface.cerulean.controller.mouse.*;
import org.datamanager.userinterface.cerulean.controller.entity.*;
import org.datamanager.userinterface.cerulean.model.*;
import org.datamanager.userinterface.cerulean.model.event.*;
import org.datamanager.userinterface.cerulean.model.data.transfer.*;

import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import java.awt.dnd.*;
import javax.swing.*;
import java.awt.geom.*;
import java.io.*;
/**
 * NewsEntityComponent
 */
public class NewsEntityComponent extends InterfaceEntityComponent implements Displayable { 
	public NewsEntityComponent() {
  		this(new InterfaceEntity());
		}
	public NewsEntityComponent(InterfaceEntity entity) {
		super(entity);
		}
	public void openEntity() {
		NewsViewer viewer = new NewsViewer();

		String header = extractString("Headers");
		viewer.setHeader(header);

		String newsgroup = extractString("NewsGroup");
		viewer.setNewsgroup(newsgroup);

		String server = extractString("Server");
		viewer.setServer(server);

		String author = extractString("Author");
		viewer.setAuthor(author);
		
		String subject = getInterfaceEntity().getName();
		viewer.setSubject(subject);	

		InterfaceEntity messageEntity = getInterfaceEntity();
		String message = messageEntity.getValue().toString();

		viewer.setMessage(message);

		viewer.setVisible(true);
		}
	private String extractString(String attributeName) {
		InterfaceAttribute attribute = getInterfaceEntity().getAttribute(attributeName);
		String content = "";
		if (attribute != null) {
			content = attribute.getValue().toString();
			}
		return content;
		}
	}