package org.datamanager.userinterface.cerulean.view.component;
import org.datamanager.userinterface.cerulean.view.icon.*;
import org.datamanager.userinterface.cerulean.view.*;
import org.datamanager.userinterface.cerulean.model.*;
import org.datamanager.userinterface.cerulean.model.data.transfer.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.awt.geom.*;
/**
 * The pane upon which the stage is placed.  It allows mouse events to
 * pass through it if a contained component is not hit.  
 * 
 * @see Stage
 * @see StageComponent
 */
public class StagePane extends CirclePane {
	private StageComponent stage;
/**
 * Create a new StagePane that is opaque and visible,
 */
	public StagePane() {
		super();
		setLayout(new BorderLayout());
		setVisible(true);
		setOpaque(false);
		stage = new StageComponent();
		addImpl(stage, BorderLayout.CENTER, -1);
		}
/**
 * Retrieve the stage component
 * @return the StageComponent contained by the pane.
 */
	public StageComponent getStage() {
		return stage;
		}
/**
 * Retrieve the shape of the stage.
 * @return the shape of the stage.
 */
	public Shape getStageShape() {
		return stage.getStageShape();
		}
	}
		
