package org.datamanager.userinterface.cerulean.view.tree;

import org.datamanager.userinterface.cerulean.view.tree.EntityTree;
import javax.swing.JScrollPane;
import javax.swing.border.EmptyBorder;
import java.awt.Container;
import java.awt.Dimension;

/**
 *This is the scroll pane for the EntityTree class.  So that the user can 
 *see all of the information in the tree. 
 *
 *@author Bryan Dawson (bdawson@indiana.edu)
 *@author Gordon Murphy (gpmurphy@indiana.edu)
 *
 *@see SidePanel
 *@see EntityTree
 *@see JScrollPane
 */

//  methods:
//  ~~~~~~~~
//  public EntityTreePane( )
//   	Creates the pane with the EntityTree as a component.
///////////////////////////////////////////////////////////////////////

public class EntityTreePane extends JScrollPane
   {
   //the EntityTree that this contains
   private EntityTree tree;
   
   //The container that this scroll pane belongs to
   private Container container;
   
   ////////////////////////////////////////////////////////////////
   /**
    * Setup the pane with an EntityTree as the only component.
    */
   public EntityTreePane()
      {
           
      tree = new EntityTree();
      getViewport().setView(tree);
      this.setOpaque(false); 
      setPreferredSize(new Dimension(200,100));
  
      }
  		
   }            			      			
    	
