package org.datamanager.userinterface.cerulean.view.undo;

import org.datamanager.userinterface.cerulean.model.undo.HistoryListModel;
import org.datamanager.userinterface.cerulean.view.undo.InterfaceListCellRenderer;

import org.datamanager.userinterface.cerulean.controller.undo.ListClickHandler;
import javax.swing.JList;
import javax.swing.ListSelectionModel;

/**
 *This class is responsible for displaying all of the InterfaceUndoEdit's that
 *occur in a session of Knownspace.  This class is relayed the
 *InterfaceUndoEdit's via UndoableEvent's.  It also knows when to remove an
 *edit for the model when it recieves UndoDiedEvent's.  In reality it is the
 *HistoryListModel it keeps track of all of that.
 *
 *@author Bryan Dawson <a href=mailto:bdawson@indiana.edu>bdawson@indiana.edu</a>
 *@author Gordon Murphy <a href=mailto:gpmurphy@indiana.edu>gpmurphy@indiana.edu</a>
 *
 *@see HistoryListModel
 *@see InterfaceListCellRenderer
 *@see ListClickHandler
 */

// Mehtods(also see JList):
// ~~~~~~~~~~~~~~~~~~~~~~~~
// public HistoryList()
//         Creates all the components of the list (ie model, renderer, etc.).
/////////////////////////////////////////////////////////////////////



public class HistoryList extends JList
   {
   ////////////////////////////////////////////////////////
   /**
    *Create the components of the list (the model, renderer, etc) and
    *  put it all together.
    */
   public HistoryList()
      {
      //set the model and renderer
      this.setModel(new HistoryListModel());
      this.setCellRenderer(new InterfaceListCellRenderer());

      //make it transparent and single selection only
      this.setOpaque(false);
      this.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
      
      // this.addListSelectionListener(new ListSelectionHandler(this));
      this.addMouseListener(new ListClickHandler(this));
      }

   }//end of class
      
 
