package org.datamanager.userinterface.cerulean.view.viewer;

import org.datamanager.userinterface.cerulean.view.icon.*;

import org.datamanager.userinterface.cerulean.view.*;
import org.datamanager.userinterface.cerulean.view.viewer.*;
import org.datamanager.userinterface.cerulean.controller.drop.*;
import org.datamanager.userinterface.cerulean.controller.mouse.*;
import org.datamanager.userinterface.cerulean.controller.entity.*;
import org.datamanager.userinterface.cerulean.model.*;
import org.datamanager.userinterface.cerulean.model.data.storage.*;
import org.datamanager.userinterface.cerulean.model.event.*;
import org.datamanager.userinterface.cerulean.model.data.transfer.*;

import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import java.awt.dnd.*;
import javax.swing.*;
import javax.swing.tree.TreePath;
import java.awt.geom.*;
import java.io.*;
import java.util.*;
/**
 * NewsViewer.  A very simple viewer that displays the header,
 * author, server, subject and message of a newsgroup article.
 */
public class AttributeViewer extends JDialog {
	private JTree attributeTree;
/**
 * Create a new NewsViewer
 */

	public AttributeViewer(InterfaceEntity entity) {
		Hashtable hashtable = new Hashtable();
		Hashtable table = constructTree(entity);
		hashtable.put(entity.getEntityName(), table);
		attributeTree = new JTree(hashtable);
		attributeTree.expandPath( new TreePath(attributeTree.getModel().getRoot()));
		JScrollPane pane = new JScrollPane(attributeTree);
		getContentPane().setLayout(new BorderLayout());
		getContentPane().add(pane, BorderLayout.CENTER);
		setSize(attributeTree.getPreferredSize());
		}
	public Hashtable constructTree(InterfaceEntity entity) {
		Hashtable table = getAllAttributes(entity);
		return table;
		}
	public Hashtable getAllAttributes(InterfaceEntity entity) {
		Hashtable table = new Hashtable();
		InterfaceAttributeList list = entity.getAttributes();
		for (int i = 0; i < list.size(); i++) {
			if (entity.isAttributeAttached()) {
				Hashtable attributeTable = getAllAttributes(list.elementAt(i));
				String displayString = list.elementAt(i).getEntityName() + ": " +
							list.elementAt(i).getValue();
				table.put(displayString, attributeTable);
				}
			}
		return table;
		}
	public void setVisible(boolean isVisible) {
		super.setVisible(isVisible);
		setSize(300, 400);
		}
	}