package org.datamanager.userinterface.cerulean.view.viewer;

import java.io.IOException;
import java.lang.ArrayIndexOutOfBoundsException;
import javax.swing.JFrame;
import javax.swing.JEditorPane;
import javax.swing.JScrollPane;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkListener;
import javax.swing.JComponent;
import org.datamanager.tools.Debug;
import java.net.URL;
/**
 * Display the given HTML file on a frame
 * @see org.datamanager.tools.Debug; 
 */

public class HtmlViewer extends JFrame
    {
    /** the width of the HtmlViewer **/
    private static final int WIDTH = 480;

    /** the height of the HtmlViewer **/
    private static final int HEIGHT = 600;
    private String source, location;
    /////////////////////////////////////////////////////////////////////

    /** the actual constructor **/
	public HtmlViewer() {
		setSize(600, 480);
		}
	public void setLocation(String url) {
		this.location = url;
		}
	public void setSource(String source) {
		this.source = source;
		}
	public JComponent createViewer(String source, String url) {
		JEditorPane pane;
            // fetch an actual html file and create a JEditorPane object.
		try {
			URL validUrl = new URL(url);
			pane = new JEditorPane (url);
			}
		catch (IOException exception) {
			pane = new JEditorPane ("text/html", source);
			}
	
        // make the HtmlViewer uneditable.
        pane.setEditable(false);

        // add a hyperlink listener
        final JEditorPane finalPane = pane;

        // add the hyperlink listener on the HtmlViewer.
	try 
	    {
	    pane.addHyperlinkListener (new HyperlinkListener()
                    {
                    public void hyperlinkUpdate(HyperlinkEvent hyperEvent)
                        {
                        try
                            {
                            if (hyperEvent.getEventType() ==
                                    HyperlinkEvent.EventType.ACTIVATED)
                                {
                                finalPane.setPage(hyperEvent.getURL());
                                }
                            }

                        catch (IOException ioexception2)
                            {
                            ioexception2.printStackTrace();
                            }
                        }
                    }
		    );
	    }
	catch (ArrayIndexOutOfBoundsException badArray)
	    {
	    }
	  return new JScrollPane(pane);
        } 

    public void setVisible(boolean isVisible) {
		getContentPane().add(createViewer(source, location));
		super.setVisible(isVisible);
		setTitle(location);
		}

    } // class HtmlViewer
