import org.datamanager.tools.Information;
import org.datamanager.passiveentityvalue.*;
import org.datamanager.constraint.*;
import org.datamanager.exception.*;
import org.datamanager.event.*;
import org.datamanager.kernel.*;

import org.datamanager.engine.*;
import org.datamanager.engine.cluster.*;
import org.datamanager.engine.tools.*;

/**
 * This simpleton mission is to throw some documents 
 * into pool to allow testing. Each document has attached mime-type.
 *
 * mime-type: "text/html" 
 */
public class EngineTestSimpleton extends Simpleton {

    public EngineTestSimpleton() {
    }

    public Information getInformation() {
	String[] authors = {"Aleksander Slominski"};
	return new Information("3-EngineTest","Throw few test so engine can munch something", "long", "1.0", authors);
    }

    public void process() {
	trace("test engine started");
	org.datamanager.tools.Debug.setDebugger(false);
	try {
	    sample("Hello there, this is a test dfsfds dsf  sdffd sfdfds !");
	    sample("Hello there, this is A!jgf   gh j j h hfhhhfhf");
	    sample("Hello there, this is B! vxvcxzvc vxc z zvcvzcvc");
	    sample("Java is everywhere");
	    sample("Where is Java");
	    sample("Caveat compruter!");
	    sample("Caveat compruter caveat!");
	    sample("Caveat compruter caveat cava!");
	    sample("Caveat compruter! caveat Java");
	}
	catch (DataManagerException ex) {
	    trace("process exception:"+ex);
	}
    }

    private static int count = 0;
    private void sample(String content) throws DataManagerException {
	Entity doc = Entity.create("test-document"+ ++count);
	doc.setValue(new StringEntityValue(content));
	Pool.getDefaultPool().add(doc);
	Entity mimeType = Entity.create("mime-type");
	mimeType.setValue(new StringEntityValue("text/html"));
	doc.attach(mimeType);
	//Pool.getDefaultPool().add(mimeType); //(1)
	//It sux! It NULLPOINTER me :-(
	//Entity[] el = mimeType.getBases(EntityConstraint.NONE);
	//mimeType.attach(doc);
	Pool pool = Pool.getDefaultPool();
	DocumentDownloadedEvent downloadEvent = new DocumentDownloadedEvent(pool, doc);
	Pool.getDefaultPool().add(downloadEvent);
    }

    private void trace(String s) {
	Trace.println(this.getClass(), s);
    }
}
