import org.datamanager.kernel.Entity;


import org.datamanager.constraint.EntityConstraint;

import org.datamanager.passiveentityvalue.DoubleEntityValue;

import org.datamanager.exception.DataManagerException;

import org.datamanager.tools.SanitySimpleton;

import org.datamanager.tools.Information;

import org.datamanager.tools.Debug;

public class EntitySanitySimpleton extends SanitySimpleton
	{
	public void sanityTestSuite()
		throws DataManagerException
		{
		Debug.assert("Enty: Entity Sanity Test");
	
		Debug.assert("Enty: Creating Entity 'subject!'... "); 
		Entity testSubject = Entity.create("subject!");
		Debug.assert("...Entity:  " + testSubject);

		Debug.assert("Enty: Creating Entity 'object!'");
		Entity testObject = Entity.create("object!");
		Debug.assert("Enty: " + 
					"testObject.setValue(new DoubleEntityValue(4.3));");
		testObject.setValue(new DoubleEntityValue(4.3));


		Debug.assert("Enty: testSubject.getName() : "
					+ testSubject.getName());
	
		Debug.assert("Enty: testObject.getName() : "
					+ testObject.getName());
		Debug.assert("Enty: testObject.getValue() : "
					+ testObject.getValue());

		Debug.assert("Enty: testSubject.attach(testObject);");
		testSubject.attach(testObject);

		Debug.assert("Enty: " + 
					"testSubject.getAttributes(Constraint.NONE) :");
	
		Entity[] attribs = testSubject.getAttributes(EntityConstraint.NONE);
		
		for (int index = 0; index < attribs.length; index++)
			{
			Debug.assert("Enty: attribs[" + index + "].getName() : "
						+ attribs[index].getName());
			}	
		}

	public Information getInformation()
		{
		String name = "EntitySanitySimpleton";
		String shortDescription =
			"Tests the sanity of entities.";
		String longDescription =
			"This class tests the sanity of the Entity class.";
		String version = "1.0";
		String[] authors = {"Ben Keil", "Matthew Farrellee"};
		return new Information(
			name,
			shortDescription,
			longDescription,
			version,
			authors);
		}
	}







