import org.datamanager.kernel.*;
import org.datamanager.constraint.*;
import org.datamanager.passiveentityvalue.*;
import org.datamanager.exception.*;
import org.datamanager.tools.*;

import org.datamanager.tools.Debug;

public class MappingSanitySimpleton extends SanitySimpleton
	{
	public void sanityTestSuite()
		throws DataManagerException
		{
		Pool pool = Pool.getDefaultPool();

		Entity[] entities;

		entities = pool.search(new NameEqualsConstraint("Subject!"));
		if (entities.length == 0)
			{
			Debug.assert("Map : Creating new subject and object");
			Entity subject = Entity.create("Subject!");
			pool.add(subject);
			Entity object = Entity.create("Object!");
			subject.attach(object);
			}
		else
			{
			Debug.assert("Map : Subject! found...");
			entities = entities[0].getAttributes(EntityConstraint.NONE);
			for (int i = 0; i < entities.length; i++)
				Debug.assert("Map : attribute " + i + " - " +
				entities[i]);
			}
		}

	public Information getInformation()
		{
		String name = "MappingSanitySimpleton";
		String shortDescription =
			"Tests the sanity of the state saving code.";
		String longDescription =
			"This class tests the sanity of the state saving code. " +
			"It should be run once and then the system should be " +
			"before running it again.";
		String version = "1.0";
		String[] authors = {"Ben Keil", "Matthew Farrellee"};
		return new Information(
			name,
			shortDescription,
			longDescription,
			version,
			authors);
		}
	}