import org.datamanager.tools.Information;
import org.datamanager.constraint.*;
import org.datamanager.kernel.*;
import org.datamanager.event.*;
import org.datamanager.passiveentityvalue.*;
import org.datamanager.exception.*;
import org.datamanager.tools.*;


public class SubscriptionSanitySimpleton
	extends SanitySimpleton
	implements EventHandler
	{

	public void sanityTestSuite()
		throws DataManagerException
		{
		out("creating entity1");
		Entity entity1 = Entity.create("entity1");
		out("created entity1");
		out("subscribing to entity1 with EventConstraint.NONE");
		entity1.subscribe(this, EventConstraint.NONE);
		out("subscribed to entity1 with EvenConstraint.NONE");
		out("setting value of entity1 to null");
		entity1.setValue(null);
		out("set value of entity1 to null");
		out("this should not have caused an event: null!=EntityValue");
		
		out("setting value of entity1 to BooleanEntityValue.FALSE");
		entity1.setValue(BooleanEntityValue.FALSE);
		out("set value of entity1 to BooleanEntityValue.FALSE");
		out("this should not cause an event: null!=EntityValue");

		out("setting value of entity1 to BooleanEntityValue.TRUE");
		entity1.setValue(BooleanEntityValue.TRUE);
		out("set value of entity1 to BooleanEntityValue.TRUE");
		out("this should cause an event to be fired");
		
		out("getting the value of entity1");
		out("entity1.getValue(): " + entity1.getValue());
		out("this should have caused an event to be fired");
		}

	private void out(String message)
		{
		Debug.assert("SSS: " + message);
		}

	private void outh(String message)
		{
		Debug.assert("SSS.handle: " + message);
		}

	public void handle(DataManagerEvent event)
		{
		outh("received event: " + event);
		outh("event received from thread: " + Thread.currentThread());
		}

	public Information getInformation()
		{
		String name = "SubscriptionSanitySimpleton";
		String shortDescription =
			"Tests the sanity of entity's subscription.";
		String longDescription =
			"This class tests the sanity of the Entity class.";
		String version = "1.0";
		String[] authors = {"Matthew Farrellee", "Ben Keil"};
		return new Information(
			name,
			shortDescription,
			longDescription,
			version,
			authors);
		}

	}
